﻿using RS.Lib;
using RS.Lib.Utils;
using RS.Web;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;

namespace Apollo
{
    public partial class UpFile : System.Web.UI.Page
    {
        string _PostSuccess = "";
        protected void Page_Load(object sender, EventArgs e)
        {
            string Command = WebHelper.GetRequestValue("Command");
            if (Command == "Upload") //是上传图片
            {
                JsonReturn jr = SaveUploadPhoto();
                _PostSuccess = WebHelper.JSON.Serialize(jr);
            }
        }

        public string PostSuccess { get { return _PostSuccess; } }
        /// <summary>
        /// 保存上传的图片
        /// </summary>
        /// <returns></returns>
        public JsonReturn SaveUploadPhoto()
        {
            string dataJson = WebHelper.GetRequestValue("ApolloPhotoData");
            DynamicObj data = WebHelper.JSON.Deserialize<DynamicObj>(dataJson);

            int imgWH = data.Get<int>("ImageMaxWH");//图片最大宽高
            if (imgWH == 0) imgWH = 1024;

            string PathName = data.Get<string>("PathName");
            if (PathName.IsWhiteSpace()) PathName = "MBPhoto/UserPhoto";

            if (Request.Files.Count > 0)//上传了文件
            {
                var file = Request.Files["ApolloPhotoBox"];
                if (file != null)
                {
                    if (!file.ContentType.StartsWith("image/"))
                        return JsonReturn.RunFail("只能上传图片文件");


                    Image oldimg = Image.FromStream(file.InputStream);
                    Image img = ImageHelper.GetThumbnail(oldimg, imgWH);//压缩为500宽

                    //配置存放的根目录
                    string uploadPath = LibHelper.GetAppSetting("RSUPFilePath");
                    //配置访问的目录
                    string webVirPath = LibHelper.GetAppSetting("RSUPVirthPath");
                    UploadPathInfo pathInfo = PathUtils.CreateUploadPath(PathName, UploadPathType.MonthlyChildDir, uploadPath, webVirPath);

                    //上传的图片暂存为如下格式：uh20160816_AB0000000001
                    string en = Path.GetExtension(file.FileName);
                    if (en.StartsWith("."))
                    {
                        if (en.Length > 1)
                            en = en.Substring(1);
                        else
                            en = "";
                    }
                    string fn = string.Format("{0}.{1}", PathUtils.CreateUpFileNameNoExp("", UploadFielNameType.RandomName), en);
                    img.Save(Path.Combine(pathInfo.PhysicalPath, fn));

                    return JsonReturn.RunSuccess(new { vfile = string.Format("{0}/{1}", pathInfo.VirthPath, fn), file = string.Format("{0}\\{1}", pathInfo.PhysicalPath, fn) });
                }
                else
                    return JsonReturn.RunFail("未上传图片");
            }
            else
                return JsonReturn.RunFail("未上传图片");
        }
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            Response.ContentEncoding = System.Text.Encoding.UTF8;
            Request.ContentEncoding = System.Text.Encoding.UTF8;
        }
    }
}